Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able
Interface AbleRemoteBean

All Superinterfaces:
  AbleEventListenerRemoteManager, AbleEventQueueRemoteManager, AbleRemoteEventListener, java.rmi.Remote, java.io.Serializable

All Known Subinterfaces:
  AblePlatformAgent, AbleRemoteAgent, AbleRemoteDataSink, AbleRemoteDataSource, AutotuneAgentIf, JasKnnDistributedAgentIF, JasNaiveBayesDistributedAgentIF

All Known Implementing Classes:
  AblePlatformDefaultAgent, AbleRemoteDefaultAgent, AbleRemoteObject, AutotuneAgent, JasKnnDistributedAgent, JasNaiveBayesDistributedAgent

public interface AbleRemoteBean
extends java.rmi.Remote, AbleRemoteEventListener, AbleEventListenerRemoteManager, AbleEventQueueRemoteManager

The AbleRemoteBean interface represents the unique behaviors required for remote AbleBeans. It extends interfaces required for event processing as well as providing specific methods for its name, state parentage, and methods which result in state changes such as `init()`, `suspendAll()` and `reset()`.

Method Summary
`java.lang.String` | `getName()` Returns the name of this bean.
`java.util.Map` | `getProperties()` Returns the entire current collection of properties.
`java.lang.String` | `getProperty(java.lang.String theName)` Gets the property associated with the specified name.
`int` | `getState()` Returns the current state of this bean.
`void` | `init()` Initializes and configures the bean.
`void` | `init(java.lang.Object theArg)` Initializes and configures the bean, using the specified Object.
`void` | `process()` Performs the main, synchronous, standard processing function performed by this bean.
`java.lang.Object` | `process(java.lang.Object theArg)` Performs the main, standard processing function performed by this bean, using the argument Object (usually passed via an AbleEvent).
`void` | `quitAll()` Stops all of the bean's asynchronous threads of control.
`java.lang.String` | `removeProperty(java.lang.String theName)` Removes the property and the specified name from the collection of properties.
`void` | `reset()` Resets this bean.
`void` | `resumeAll()` Resumes all of the bean's suspended asynchronous threads of control.
`void` | `setProperties(java.util.Map theProperties)` Sets the entire collection of properties to the specified collection.
`void` | `setProperty(java.lang.String theName, java.lang.String theValue)` Sets the specified property to the specified value.
`void` | `suspendAll()` Suspends, temporarily, all of the bean's asynchronous threads of control.

Methods inherited from interface com.ibm.able.AbleRemoteEventListener
`handleAbleEvent`

Methods inherited from interface com.ibm.able.AbleEventListenerRemoteManager
`addAbleEventListener, notifyAbleEventListeners, removeAbleEventListener`

Methods inherited from interface com.ibm.able.AbleEventQueueRemoteManager
`flushAbleEventQueue, getAbleEventProcessingEnabled, getAbleEventQueueSize, getSleepTime, isTimerEventProcessingEnabled, quitEnabledEventProcessing, restartEnabledEventProcessing, resumeEnabledEventProcessing, setAbleEventProcessingEnabled, setSleepTime, setTimerEventProcessingEnabled, startEnabledEventProcessing, suspendEnabledEventProcessing`

Method Detail

### getName

    public java.lang.String getName()
                             throws java.rmi.RemoteException

  Returns the name of this bean.

  Returns:
    The current name of this AbleRemoteBean object or the empty string if no name has been set. The value is never expected to be null.
  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### getState

    public int getState()
                 throws java.rmi.RemoteException

  Returns the current state of this bean.

  Returns:
    An `AbleState` value.
  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### init

    public void init()
              throws java.rmi.RemoteException

  Initializes and configures the bean. If needed, this method calls `AbleEventQueueRemoteManager.startEnabledEventProcessing()` to start a new thread for asynchronous or timer event processing. The bean's state changes to `AbleState.Initiated` or `AbleState.Waiting`.

  A bean implementing `AbleBeanRemoteContainer` may choose to call this method on each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### init

    public void init(java.lang.Object theArg)
              throws java.rmi.RemoteException

  Initializes and configures the bean, using the specified Object. If needed, this method calls `AbleEventQueueRemoteManager.startEnabledEventProcessing()` to start a new thread for asynchronous or timer event processing. The bean's state changes to `AbleState.Initiated` or `AbleState.Waiting`.

  A bean implementing `AbleBeanContainer` may choose to call this method on each bean it contains and accumulate errors from each contained bean.

  Parameters:
    `theArg` - An Object used to initialize the bean, typically by getting parameters of interest.
  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### reset

    public void reset()
               throws java.rmi.RemoteException

  Resets this bean. The implementation is highly bean dependent. Issues for implementors to consider are described in `AbleBean.reset()`.

  A bean implementing `AbleBeanRemoteContainer` should reset each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### process

    public void process()
                 throws java.rmi.RemoteException

  Performs the main, synchronous, standard processing function performed by this bean. Typically, this function involves taking data from the input buffer, processing the data, creating an output buffer, and placing the processed data into it.

  A bean implementing `AbleBeanRemoteContainer` may choose to call process on each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### process

    public java.lang.Object process(java.lang.Object theArg)
                             throws java.rmi.RemoteException

  Performs the main, standard processing function performed by this bean, using the argument Object (usually passed via an AbleEvent). Typically, this function involves taking data from the argument object, processing the data, and placing the processed data into an AbleEvent.

  A bean implementing `AbleBeanRemoteContainer` may choose to call process on each bean it contains and accumulate errors from each contained bean.

  Parameters:
    `theArg` - An Object used to provide data for the bean derive a result.
  Returns:
    The results of the process() computation, usually a clone of the bean's OutputBuffer.
  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### quitAll

    public void quitAll()
                 throws java.rmi.RemoteException

  Stops all of the bean's asynchronous threads of control. The bean's state changes to `AbleState.Unknown`.

  If the bean is a simple AbleBean, this method just calls `AbleEventQueueRemoteManager.quitEnabledEventProcessing()`. A bean implementing `AbleBeanRemoteContainer` should call quitAll on each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### suspendAll

    public void suspendAll()
                    throws java.rmi.RemoteException

  Suspends, temporarily, all of the bean's asynchronous threads of control. The bean's state changes to `AbleState.Suspended`.

  If the bean is a simple AbleBean, this method just calls `AbleEventQueueRemoteManager.suspendEnabledEventProcessing()`. A bean implementing `AbleBeanRemoteContainer` should call this method on each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### resumeAll

    public void resumeAll()
                   throws java.rmi.RemoteException

  Resumes all of the bean's suspended asynchronous threads of control. The bean's state changes from `AbleState.Suspended` to `AbleState.Waiting`.

  If the bean is a simple AbleBean, this method just calls `AbleEventQueueRemoteManager.resumeEnabledEventProcessing()`. A bean implementing `AbleBeanRemoteContainer` should call this method on each bean it contains and accumulate errors from each contained bean.

  Throws:
    `java.rmi.RemoteException` - If an error occurs.

### setProperty

    public void setProperty(java.lang.String theName,
                            java.lang.String theValue)
                     throws java.rmi.RemoteException

  Sets the specified property to the specified value.

  Parameters:
    `theName` - The name of the property to be placed into the collection of properties.
    `theValue` - The value associated with the specified property.
  Throws:
    `java.rmi.RemoteException`
  Since:
    2.3.0

### getProperty

    public java.lang.String getProperty(java.lang.String theName)
                                 throws java.rmi.RemoteException

  Gets the property associated with the specified name.

  Parameters:
    `theName` - The name of the property to be returned.
  Returns:
    The value associated with the specified name, or null if no property has been set for the specified name.
  Throws:
    `java.rmi.RemoteException`
  Since:
    2.3.0

### removeProperty

    public java.lang.String removeProperty(java.lang.String theName)
                                    throws java.rmi.RemoteException

  Removes the property and the specified name from the collection of properties.

  Parameters:
    `theName` - The name of the property to be removed.
  Returns:
    The value associated with the specified name, or null if no property has been set for the specified name.
  Throws:
    `java.rmi.RemoteException`
  Since:
    2.3.0

### setProperties

    public void setProperties(java.util.Map theProperties)
                       throws java.rmi.RemoteException

  Sets the entire collection of properties to the specified collection.

  Parameters:
    `theProperties` - The set of properties that will replace the current collection of properties. If this parameter is specified as null, the call is ignored; that is, the underlying data member is not changed. Otherwise, the underlying data member is changed to point to the specified collection.

    Keys and values of the properties collection must be confined to the String data type.

  Throws:
    `java.rmi.RemoteException`
  Since:
    2.3.0

### getProperties

    public java.util.Map getProperties()
                                throws java.rmi.RemoteException

  Returns the entire current collection of properties.

  Returns:
    The entire current collection of properties.
  Throws:
    `java.rmi.RemoteException`
  Since:
    2.3.0

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005